

// NS 2014;
// Model used in Notarpietro-Siviero 2014

%-------------------------------------------
% written 11 June 2014
%------------------------------------------

% periods=0;
%--------------------------------------------;welf,
% Give variables names and innovations (of the shocks) names
% Notice that the AR(p) shocks are added to the structural equations;tax,
%----------------------------------------------;

var RR,well,well_s,well_b, Util,stuff,stuS, stuNR,DS,AP, MC, UCbis, Y,	Z,	AP_D,MC_D,	XINR,	XI,	UCbisNR, Z_D, TOTC, 
UC,	C, UC_D, UCNR, CNR,	UC_DNR,	DNR, PSI, Debt,	L_C, L_D,  Dp, pii, ZP1, ZP2, Dp_D, PI_D, ZP1_D,	ZP2_D, W_C,	W_D, W_C_S,	N_C_S,	W_C_NR,	N_C_NR,	W_D_S, N_D_S,  W_D_NR,	N_D_NR, T_D, GDP,	R, shock_LTV, 
shock_H;				
//P_L,pledge, cgap, stuff,
varexo E_LTV,E_H ;  

%-----------------------------------------------;
% GIVE PARAMETER'S NAMES
%----------------------------------------------;
parameters constL, constW, nbeta, mu, muw_C, muw_D,	subv,	betta,	sig_c,	phi_y,	gamma_p,	xi_p,	sig_l_C,	r_PI,	r_dy,	rho,	Lst,	tau_D,	hetha_D,	omega_D,	chi_NR,	omega_NR,	phi_y_D,	alph_D, xi_p_D,	gamma_p_D,	mu_D,	subv_D,	rho_LTV,	rho_H,	alph_LAN, diff_betta,	r_PID,	betta_NR,	sig_l_D, sig_l_C_NR,	sig_l_D_NR,	
LANDst, Z_ss, Z_D_ss, Gst, TRS, R_ss, GDP_ss, pii_ss, PI_D_ss, LCBAR,  LDBAR,  LC_NRBAR,  LD_NRBAR, std_LTV, std_H, poly, std_P;			
										
									
%---------------------------------------------------;
% start here 
%---------------------------------------------------;
model;
well = (1-omega_NR)*(1-betta)*well_s + omega_NR*(1-betta_NR)*well_b;
well_s = stuS + betta*well_s(+1);
well_b = stuNR + betta_NR*well_b(+1);
Util=stuff;      
stuS=log(XI)-LCBAR*(N_C_S)^(1+sig_l_C)/(1+sig_l_C)-LDBAR*(N_D_S)^(1+sig_l_D)/(1+sig_l_D)  ;
stuNR=log(XINR)-LC_NRBAR*(N_C_NR)^(1+sig_l_C_NR)/(1+sig_l_C_NR)-LD_NRBAR*(N_D_NR)^(1+sig_l_D_NR)/(1+sig_l_D_NR);
stuff = (1-omega_NR)*(1-betta)*(stuS) + omega_NR*(1-betta_NR)*(stuNR) ;
Z=(L_C)-(phi_y-1)*Z_ss;									
Z_D=(L_D)-(phi_y_D-1)*Z_D_ss;									
AP=(pii)*(pii(-1))^(-gamma_p)*(pii_ss)^(gamma_p-1);										
AP_D=(1+PI_D)*(1+PI_D(-1))^(-gamma_p_D)*(1+PI_D_ss)^(gamma_p_D-1);										
MC=W_C;												
MC_D=W_D;											
XI=(C^(1-exp(shock_H)*omega_D))*(DS^(exp(shock_H)*omega_D))*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
UCbis=1/XI;												
XINR= (CNR^(1-exp(shock_H)*omega_D))*(DNR^(exp(shock_H)*omega_D))*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
UCbisNR=1/XINR;												
UC= UCbis*(1-exp(shock_H)*omega_D)*(C/DS)^(-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
UC_D= UCbis*exp(shock_H)*omega_D*(C/DS)^(1-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
Y=omega_NR*CNR+(1-omega_NR)*C + Gst*Z_ss;		
T_D*UC=UC_D+betta*(1-tau_D)*UC(+1)*T_D(+1);									
UC=UC(+1)*betta*(1+R)/(pii(+1));											
UCNR= UCbisNR*(1-exp(shock_H)*omega_D)*(CNR/DNR)^(-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));								
UC_DNR= UCbisNR*exp(shock_H)*omega_D*(CNR/DNR)^(1-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
T_D*UCNR=T_D(+1)*((pii(+1))/(1+R))*exp(shock_LTV)*(1-chi_NR)*PSI*UCNR+UC_DNR+betta_NR*(1-tau_D)*UCNR(+1)*T_D(+1);							
PSI=1-betta_NR*UCNR(+1)/UCNR*(1+R)/(pii(+1));									
Debt=exp(shock_LTV)*(1-chi_NR)*T_D(+1)*DNR*(pii(+1))/(1+R);											
CNR=-T_D*(DNR-(1-tau_D)*DNR(-1))-(1+R(-1))/(pii)*Debt(-1)+Debt+((N_C_NR*W_C_NR+N_D_NR*W_D_NR))+TRS;
Z=Dp*Y;										
Z_D=Dp_D*((1-omega_NR)*(DS-(1-tau_D)*DS(-1))+omega_NR*(DNR-(1-tau_D)*DNR(-1)));					
W_C=W_C_S^(1-omega_NR)*W_C_NR^omega_NR/(omega_NR^omega_NR*(1-omega_NR)^(1-omega_NR));												
W_D= constW*W_D_S^(1-omega_NR)*W_D_NR^omega_NR/(omega_NR^omega_NR*(1-omega_NR)^(1-omega_NR));												
L_C=(N_C_S)^(1-omega_NR)*(N_C_NR)^omega_NR;											
L_D=constL*(N_D_S)^(1-omega_NR)*(N_D_NR)^omega_NR;											
omega_NR*(N_C_S)*W_C_S=(1-omega_NR)*(N_C_NR)*W_C_NR;										
omega_NR*(N_D_S)*W_D_S=(1-omega_NR)*(N_D_NR)*W_D_NR;											
W_C_S =  (LCBAR*(N_C_S)^(sig_l_C))*(1/UC);												
W_C_NR = (LC_NRBAR*(N_C_NR)^(sig_l_C))*(1/UCNR);
W_D_S = (LDBAR*(N_D_S)^(sig_l_D))*(1/UC);
W_D_NR = (LD_NRBAR*(N_D_NR)^(sig_l_D))*(1/UCNR);	
Dp_D=(1-xi_p_D)*(mu_D*(1-subv_D)*ZP1_D/ZP2_D)^(-mu_D/(mu_D-1))+xi_p_D*Dp_D(-1)*AP_D^(mu_D/(mu_D-1));									
(mu_D*(1-subv_D)*ZP1_D/ZP2_D)^(1/(1-mu_D))*(1-xi_p_D)=1-xi_p_D*AP_D^(1/(mu_D-1));						
ZP1_D=UC*MC_D*Z_D*T_D+betta*xi_p_D*AP_D(+1)^(mu_D/(mu_D-1))*ZP1_D(+1);							
ZP2_D=UC*Z_D*T_D+betta*xi_p_D*AP_D(+1)^(1/(mu_D-1))*ZP2_D(+1);							
Dp=(1-xi_p)*(mu*(1-subv)*ZP1/ZP2)^(-mu/(mu-1))+xi_p*Dp(-1)*AP^(mu/(mu-1));	
(mu*(1-subv)*ZP1/ZP2)^(1/(1-mu))*(1-xi_p)=1-xi_p*AP^(1/(mu-1));						
ZP1=UC*MC*Z+betta*xi_p*AP(+1)^(mu/(mu-1))*ZP1(+1);							
ZP2=UC*Z+betta*xi_p*AP(+1)^(1/(mu-1))*ZP2(+1);	
T_D=T_D(-1)*(1+PI_D)/(pii);		
poly-((1+R)/(1+R_ss))+((pii/pii_ss)^((r_PI)*(1-rho)))*((GDP/GDP(-1))^(r_dy*(1-rho)))*(((1+PI_D)/(1+PI_D_ss))^(r_PID*(1-rho)))*(((1+R(-1))/(1+R_ss))^rho);										
//pii = pii_ss;
GDP=Z+Z_D*T_D;					
TOTC = omega_NR*CNR + (1-omega_NR)*C;	
RR  = (R  /pii(+1));
// Exogenous shocks;											
shock_LTV=rho_LTV*shock_LTV(-1)+E_LTV;
shock_H=rho_H*shock_H(-1)+ E_H ;
end;														



steady;
resid;
check;


shocks;
var	E_LTV   = std_LTV^2;
var	E_H     = std_H^2;
end;


%==========================================================================

options_.nograph = 1;
stoch_simul(order=1,irf=20);
figure(1)
subplot(5,2,1)
plot(4*oo_.irfs.R_E_H,'r','LineWidth',2)
legend('Policy rate')
subplot(5,2,2)
plot(oo_.irfs.Y_E_H,'b','LineWidth',2)
legend('GDP')
subplot(5,2,3)
plot(4*oo_.irfs.pii_E_H,'k','LineWidth',2)
legend('inflation')
subplot(5,2,4)
plot(oo_.irfs.T_D_E_H,'b-o','LineWidth',2)
legend('house price')
subplot(5,2,5)
plot(oo_.irfs.C_E_H,'r-x','LineWidth',2)
legend('Cp')
subplot(5,2,6)
plot(oo_.irfs.CNR_E_H,'b-x','LineWidth',2)
legend('Ci')
subplot(5,2,7)
plot(oo_.irfs.Debt_E_H,'k-o','LineWidth',2)
legend('Debt')
subplot(5,2,8)
plot(oo_.irfs.DNR_E_H,'k-o','LineWidth',2)
legend('Housing impatient')
subplot(5,2,9)
plot(oo_.irfs.DS_E_H,'k-o','LineWidth',2)
legend('Housing patient')
subplot(5,2,10)
plot(oo_.irfs.XI_E_H,'k-o','LineWidth',2)
legend('XI')



figure(2)
subplot(5,2,1)
plot(4*oo_.irfs.R_E_LTV,'r','LineWidth',2)
legend('Policy rate')
subplot(5,2,2)
plot(oo_.irfs.Y_E_LTV,'b','LineWidth',2)
legend('GDP')
subplot(5,2,3)
plot(4*oo_.irfs.pii_E_LTV,'k','LineWidth',2)
legend('inflation')
subplot(5,2,4)
plot(oo_.irfs.T_D_E_LTV,'b-o','LineWidth',2)
legend('house price')
subplot(5,2,5)
plot(oo_.irfs.C_E_LTV,'r-x','LineWidth',2)
legend('Cp')
subplot(5,2,6)
plot(oo_.irfs.CNR_E_LTV,'b-x','LineWidth',2)
legend('Ci')
subplot(5,2,7)
plot(oo_.irfs.Debt_E_LTV,'k-o','LineWidth',2)
legend('Debt')
subplot(5,2,8)
plot(oo_.irfs.DNR_E_LTV,'k-o','LineWidth',2)
legend('Housing impatient')
subplot(5,2,9)
plot(oo_.irfs.DS_E_LTV,'k-o','LineWidth',2)
legend('Housing patient')
subplot(5,2,10)
plot(oo_.irfs.TOTC_E_LTV,'k-o','LineWidth',2)
legend('Total consumption')
%==========================================================================


stoch_simul(order=2,irf=0);

 betta = 0.99;
 betta_NR = 0.9601;
 
 
 w1 = oo_.dr.order_var; 
 windx1 = strmatch('well',M_.endo_names(w1,:),'exact');
 a1=0.5*oo_.dr.ghs2(windx1);
 oldindx1 = strmatch('well',M_.endo_names,'exact'); 
 a11 = oo_.dr.ys(oldindx1);
 Ut         =  a11 + a1 ;
 
 ws = oo_.dr.order_var; %
 windxs = strmatch('well_s',M_.endo_names(ws,:),'exact');
 as=0.5*oo_.dr.ghs2(windxs);
 oldindxs = strmatch('well_s',M_.endo_names,'exact'); 
 as1 = oo_.dr.ys(oldindxs);%
 Uts            =  as1 + as ;
 
 wnr = oo_.dr.order_var; 
 windxnr = strmatch('well_b',M_.endo_names(wnr,:),'exact');
 anr=0.5*oo_.dr.ghs2(windxnr);
 oldindxnr = strmatch('well_b',M_.endo_names,'exact'); 
 anr1 = oo_.dr.ys(oldindxnr);
 Utnr       =  anr1 + anr ;
 
 % Computing welfare gain/loss:
 % (cfr. NS_2014_optimalMP.mod)
 %	SOCIAL WELFARE UNDER RAMSEY POLICY         = 4.825235;
 %	SAVER WELFARE UNDER RAMSEY POLICY          = 591.332855;
 %	BORROWER WELFARE UNDER RAMSEY POLICY       = 11.839594;
 
 wel_tot     = Ut;
 wel_sav     = Uts;
 wel_bor     = Utnr;
 
 WELFRAM     = 4.825235;
 WELFRAM_S   = 591.332855;
 WELFRAM_B   = 11.839594;
 
  
 delta_welf_sav  = 1 - exp((1-betta)   *(WELFRAM_S-wel_sav));
 delta_welf_bor  = 1 - exp((1-betta_NR)*(WELFRAM_B-wel_bor));
 
  
 
  fprintf	('	SOCIAL WELFARE UNDER RAMSEY POLICY          = ')	;	fprintf	('%f',	WELFRAM);	disp(';')
  fprintf	('	SOCIAL WELFARE UNDER SIMPLE RULE            = ')	;	fprintf	('%f',	Ut	);	disp(';')
  fprintf	('	SAVER WELFARE UNDER RAMSEY POLICY           = ')	;	fprintf	('%f',	WELFRAM_S);	disp(';')
  fprintf	('	SAVER WELFARE UNDER SIMPLE RULE             = ')	;	fprintf	('%f',	Uts);	disp(';')
  fprintf	('	BORROWER WELFARE UNDER RAMSEY POLICY        = ')	;	fprintf	('%f',	WELFRAM_B);	disp(';')
  fprintf	('	BORROWER WELFARE UNDER SIMPLE RULE          = ')	;	fprintf	('%f',	Utnr);	disp(';')
  fprintf	('	WELFARE GAIN SAVER                          = ')	;	fprintf	('%f',	delta_welf_sav	);	disp(';')
  fprintf	('	WELFARE GAIN BORROWER                       = ')	;	fprintf	('%f',	delta_welf_bor	);	disp(';')
  
