

// NS 2014;

%-------------------------------------------
% written 11 June 2014
%------------------------------------------

% periods=0;
%--------------------------------------------;welf,
% Give variables names and innovations (of the shocks) names
% Notice that the AR(p) shocks are added to the structural equations;tax,
%----------------------------------------------;

var well,Util,stuS, DS,AP, MC, UCbis, Y,	Z,	AP_D,MC_D,	XI,	Z_D, 
UC,	C, UC_D, L_C, L_D,  Dp, pii, ZP1, ZP2, Dp_D, PI_D, ZP1_D,	ZP2_D, W_C,	W_D, W_C_S,	N_C_S,	W_D_S, N_D_S,  T_D, GDP,	R,
shock_H;				

varexo E_H;  

%-----------------------------------------------;
% GIVE PARAMETER'S NAMES
%----------------------------------------------;
parameters nbeta, miu, miuw_C, miuw_D,	subv,	betta,	sig_c,	phi_y,	gamma_p,	xi_p,	sig_l_C,	r_PI,	r_dy,	rho,	Lst,	tau_D,	hetha_D,	omega_D,	chi_NR,	omega_NR,	phi_y_D,	alph_D, xi_p_D,	gamma_p_D,	miu_D,	subv_D,	rho_LTV,	rho_H,	alph_LAN, diff_betta,	r_PID,	betta_NR,	sig_l_D, sig_l_C_NR,	sig_l_D_NR,	
std_H, poly;			
%LANDst, Z_ss, Z_D_ss, Gst, TRS, R_ss, GDP_ss, pii_ss, PI_D_ss, LCBAR,  LDBAR,  LC_NRBAR,  LD_NRBAR, 	constL, constW, 									



%--------------------------------------------------------------------------
pii_ss              = 1;
chi_NR              = 0.2;
hetha_D             = 1.0000001;
omega_D             = 0.1;
miu                  = 1.3;
miu_D                = miu;
subv                = 0;                  
subv_D              = 0;
phi_y_D             = miu_D*(1-subv_D);
phi_y               = miu*(1-subv);
diff_betta          = 3.15;
alph_D              = 0.3;
alpha               = 0.3;
alph_LAN            = 0.15;
betta               = 0.99;
tau_D               = 0.01;
Gst                 = 0.18;
Lst                 = 1;
omega_NR            = 0.2;
sig_l_C             = 2;
sig_l_D         	= 2;
sig_c               = 0.9999;
betta_NR            = 0.960061;
sig_l_C_NR          = 2.000000;
sig_l_D_NR          = 2.000000;

nbeta               = betta;
pii_ss              = (1.00)^(1/4); 
R_ss                = 1/betta*pii_ss - 1; 
PIBAR               = pii_ss -1;

xi_p                = 0.75;
gamma_p             = 0.0;

xi_p_D              = 0;
gamma_p_D           = 0;

alph_LAN            = 0;
miuw_C               = 1 ;
miuw_D               = 1 ;

%--------------------------------------------------------------------------
poly = 0;
%--------------------------------------------------------------------------

rho_H               =	0.95 ;
rho_LTV             =   0.95 ;
std_H               =   2.75 ;  // to obtain a 1% increase in house prices after a one-std dev shock, under pure inflation targeting

%--------------------------------------------------------------------------

r_PI    = 1.5;
r_dy    = 0.01;   
rho     = 0.85;
r_PID   = 0.0;
										

xi_p_D              = 0.75;
%==================================================================================================================================
% START LOOP 
%==================================================================================================================================
 
rho_values   = [0.0: 0.1: 1];
r_dy_values  = [0.0: 0.5: 3];
r_PI_values  = [1.1: 0.5: 5];
r_PID_values = [-0.5: 0.5: 3];%

srho  = size(rho_values,2); 
srdy  = size(r_dy_values,2); 
srpi  = size(r_PI_values,2);
srpid = size(r_PID_values,2);

tots  = srho*srdy*srpi*srpid; 

    
 BB = 0;
 hw = waitbar(0,'COMPUTING OPTIMAL MONETARY POLICY RULE...');
 for i = 1:length(rho_values); 
      rho = rho_values(i);
          for j = 1:length(r_dy_values); 
            r_dy = r_dy_values(j); 
                 for m = 1:length(r_PI_values);
                   r_PI = r_PI_values(m);
                        for n = 1:length(r_PID_values);
                          r_PID = r_PID_values(n);    



								
%---------------------------------------------------;
% start here 
%---------------------------------------------------;
model;

# pii_ss     = (1.00)^(1/4); 
# R_ss       = 1/betta*pii_ss - 1; 
# Gst        = 0.18;
# P_L_ss     = 1;
# MC_ss      = 1/(miu*(1-subv));
# MC_D_ss    = 1/(miu_D*(1-subv_D));
# W_C_ss     = MC_ss;
# W_D_ss     = MC_D_ss; 
# T_D_ss     = miu_D*(1-subv_D)*W_D_ss^(1-alph_LAN)/((1-alph_LAN)^(1-alph_LAN))*(P_L_ss/alph_LAN)^alph_LAN;
# DC_ss      = (omega_D/(1-omega_D))*(1/(T_D_ss*(1-betta*(1-tau_D))));
# LAND_LD_ss = (W_D_ss/P_L_ss)*(alph_LAN/(1-alph_LAN)); 
# ZL_ss      = 1/ phi_y;
# ZLD_ss     = (LAND_LD_ss^alph_LAN)/ phi_y_D;
 
# ZC_ss      = (1/(1-Gst));
# ZDC_ss     = tau_D*DC_ss;
# NC_ss      = (ZDC_ss*(1-omega_D)/(ZDC_ss/ZC_ss))^(1/(1+sig_l_C));
# ND_ss      = ((ZDC_ss/ZC_ss)^(1/(1+sig_l_C)))*NC_ss;

 
# L_C_ss     = NC_ss;
# Z_ss       = L_C_ss/phi_y;
# Z_D_ss     = Z_ss*((ND_ss/NC_ss)^(1+sig_l_C));
# C_ss       = 1/(ZC_ss/Z_ss);
# DS_ss      = DC_ss*C_ss;

# W_C_S_ss   = (NC_ss^sig_l_C)*C_ss/(1-omega_D);
# W_D_S_ss   = (ND_ss^sig_l_D)*C_ss/(1-omega_D);

 
# constL   = Z_D_ss*phi_y_D/ND_ss;
# L_D_ss      = constL*ND_ss;

# constW   = W_D_ss/W_D_S_ss;

# LANDst   = LAND_LD_ss * L_D_ss;
 
# Y_ss        = C_ss + Gst*Z_ss;		
 
# TRS      = 0;

# XI_ss      = (C_ss^(1-omega_D))*(DS_ss^(omega_D))*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
# UCbis_ss   = 1/XI_ss;
# UC_ss      = UCbis_ss*(1-omega_D)*(C_ss/DS_ss)^(-omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
# UC_D_ss    = UCbis_ss*omega_D*(C_ss/DS_ss)^(1-omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));

# AP_ss      = (pii_ss)^(1-gamma_p)*(pii_ss)^(gamma_p-1);	
# PI_D_ss    =  pii_ss -1 ;		
# AP_D_ss    = (1+PI_D_ss)*(1+PI_D_ss)^(-gamma_p_D)*(1+PI_D_ss)^(gamma_p_D-1);
# ZP1_D_ss   = UC_ss*MC_D_ss*Z_D_ss*T_D_ss/(1-betta*xi_p_D*AP_D_ss^(miu_D/(miu_D-1)));
# ZP2_D_ss   = UC_ss*Z_D_ss*T_D_ss/(1-betta*xi_p_D*AP_D_ss^(1/(miu_D-1)));
# ZP1_ss     = UC_ss*MC_ss*Z_ss/(1-betta*xi_p*AP_ss^(miu/(miu-1)));
# ZP2_ss     = UC_ss*Z_ss/(1-betta*xi_p*AP_ss^(1/(miu-1)));
# Dp_ss      = ((1-xi_p)*(miu*(1-subv)*ZP1_ss/ZP2_ss)^(-miu/(miu-1)))/ (1-xi_p*AP_ss^(miu/(miu-1)));
# Dp_D_ss    = ((1-xi_p_D)*(miu_D*(1-subv_D)*ZP1_D_ss/ZP2_D_ss)^(-miu_D/(miu_D-1)))/(1-xi_p_D*AP_D_ss^(miu_D/(miu_D-1)));	

# W_ss       = W_C_ss;
# WC_ss      = MC_ss ;
# WD_ss      = MC_D_ss ;
# LCBAR     = UC_ss*W_C_S_ss/(miuw_C)*(NC_ss)^(-sig_l_C);
# LDBAR     = UC_ss*W_D_S_ss/(miuw_D)*(ND_ss)^(-sig_l_D);
# GDP_ss    = Z_ss  + Z_D_ss * T_D_ss ;
 
# N_C_S_ss     = NC_ss;
# N_D_S_ss     = ND_ss;

# stuS_ss     = log(XI_ss)- LCBAR*(N_C_S_ss)^(1+sig_l_C)/(1+sig_l_C)-LDBAR*(N_D_S_ss)^(1+sig_l_D)/(1+sig_l_D);

# Util_ss     = stuS_ss;

# welf_ss     = Util_ss;

# well_ss     = Util_ss/(1-betta);

# stuff_ss    = stuS_ss;


well = Util + betta*well(+1);
Util=stuS;      
stuS=log(XI)-LCBAR*(N_C_S)^(1+sig_l_C)/(1+sig_l_C)-LDBAR*(N_D_S)^(1+sig_l_D)/(1+sig_l_D)  ;
Z=(L_C)-(phi_y-1)*Z_ss;									
Z_D=(L_D)-(phi_y_D-1)*Z_D_ss;									
AP=(pii)*(pii(-1))^(-gamma_p)*(pii_ss)^(gamma_p-1);										
AP_D=(1+PI_D)*(1+PI_D(-1))^(-gamma_p_D)*(1+PI_D_ss)^(gamma_p_D-1);										
MC=W_C;												
MC_D=W_D;											
%XI=(C^(1-exp(shock_H)*omega_D))*(DS^(exp(shock_H)*omega_D))*(1/((exp(shock_H)*omega_D^(exp(shock_H)*omega_D))*((1-exp(shock_H)*omega_D)^(1-(exp(shock_H)*omega_D)))));
%UCbis=1/XI;												
%UC= UCbis*(1-exp(shock_H)*omega_D)*(C/DS)^(-exp(shock_H)*omega_D)*(1/((exp(shock_H)*omega_D^(exp(shock_H)*omega_D))*((1-exp(shock_H)*omega_D)^(1-exp(shock_H)*omega_D))));
%UC_D= UCbis*exp(shock_H)*omega_D*(C/DS)^(1-exp(shock_H)*omega_D)*(1/((exp(shock_H)*omega_D^(exp(shock_H)*omega_D))*((1-exp(shock_H)*omega_D)^(1-exp(shock_H)*omega_D))));
XI=(C^(1-exp(shock_H)*omega_D))*(DS^(exp(shock_H)*omega_D))*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
UCbis=1/XI;												
UC= UCbis*(1-exp(shock_H)*omega_D)*(C/DS)^(-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
UC_D= UCbis*exp(shock_H)*omega_D*(C/DS)^(1-exp(shock_H)*omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
Y=C + Gst*Z_ss;		
T_D*UC=UC_D+betta*(1-tau_D)*UC(+1)*T_D(+1);									
UC=UC(+1)*betta*(1+R)/(pii(+1));											
Z=Dp*Y;										
Z_D=(DS-(1-tau_D)*DS(-1));					
W_C=W_C_S;												
W_D= constW*W_D_S;												
L_C=(N_C_S);											
L_D=constL*(N_D_S);											
W_C_S =  (LCBAR*(N_C_S)^(sig_l_C))*(1/UC);												
W_D_S = (LDBAR*(N_D_S)^(sig_l_D))*(1/UC);
Dp_D=(1-xi_p_D)*(miu_D*(1-subv_D)*ZP1_D/ZP2_D)^(-miu_D/(miu_D-1))+xi_p_D*Dp_D(-1)*AP_D^(miu_D/(miu_D-1));									
(miu_D*(1-subv_D)*ZP1_D/ZP2_D)^(1/(1-miu_D))*(1-xi_p_D)=1-xi_p_D*AP_D^(1/(miu_D-1));						
ZP1_D=UC*MC_D*Z_D*T_D+betta*xi_p_D*AP_D(+1)^(miu_D/(miu_D-1))*ZP1_D(+1);							
ZP2_D=UC*Z_D*T_D+betta*xi_p_D*AP_D(+1)^(1/(miu_D-1))*ZP2_D(+1);							
Dp=(1-xi_p)*(miu*(1-subv)*ZP1/ZP2)^(-miu/(miu-1))+xi_p*Dp(-1)*AP^(miu/(miu-1));	
(miu*(1-subv)*ZP1/ZP2)^(1/(1-miu))*(1-xi_p)=1-xi_p*AP^(1/(miu-1));						
ZP1=UC*MC*Z+betta*xi_p*AP(+1)^(miu/(miu-1))*ZP1(+1);							
ZP2=UC*Z+betta*xi_p*AP(+1)^(1/(miu-1))*ZP2(+1);	
T_D=T_D(-1)*(1+PI_D)/(pii);		
poly-((1+R)/(1+R_ss))+((pii/pii_ss)^((r_PI)*(1-rho)))*((GDP/GDP(-1))^(r_dy*(1-rho)))*(((1+PI_D)/(1+PI_D_ss))^(r_PID*(1-rho)))*(((1+R(-1))/(1+R_ss))^rho);										
//pii = pii_ss;
GDP=Z+Z_D*T_D;					
// Exogenous shocks;											
shock_H=rho_H*shock_H(-1)+E_H;


end;														

steady;
%resid;
%check;


shocks;
var	E_H     = std_H^2;


end;



% =========================================================================
%  WELFARE COST CALCULATIONS
% =========================================================================

options_.nograph=1; 
options_.noprint=1; 
stoch_simul(order=2,irf=0) ;

% =======================================================================================
% HERE I CHECK IF THE PARAMETER COMBINATION GENERATES INDETERMINACY (OR OTHER PROBLEMS): 
% IN THAT CASE, I SET delta TO A DEFAULT ARTIFICIAL VALUE
% =======================================================================================

if    info(1) > 0
    delta_welf_tot = -100 ;
    Ut             = -11111;

else


w1 = oo_.dr.order_var; 
windx1 = strmatch('well',M_.endo_names(w1,:),'exact');
a1=0.5*oo_.dr.ghs2(windx1);
oldindx1 = strmatch('well',M_.endo_names,'exact'); 
a11 = oo_.dr.ys(oldindx1);
Ut         =  a11 + a1 ;
 
 % Computing welfare gain/loss:

%WELFRAM = 598.5466;

%wel_tot = th_m;
 
%delta_welf_tot  = 1 - exp((1-betta)   *(WELFRAM-wel_tot));

end%if


% =========================================================================
%  STORAGE OF RESULTS
% =========================================================================

      pa1(i,j,m,n)      = rho_values(i);
      pa2(i,j,m,n)      = r_dy_values(j);
      pa3(i,j,m,n)      = r_PI_values(m);
      pa4(i,j,m,n)      = r_PID_values(n);

   
      welf(i,j,m,n)     = Ut;
                 
      BB = BB + 1;


      waitbar(BB/tots,hw); 
      resall = [welf(:) pa1(:) pa2(:) pa3(:) pa4(:)];                        
       
       end;
     end;
   end; 
 end;

% =========================================================================
%  SAVING RESULTS
% =========================================================================

% STORE ALL THE RESULTS IN A VECTOR, STARTING FROM OUTER LOOPING PARAMETER: for all i, take j = 1 etc 
% and put in one column. Do the same for j = 2, etc... Then start over with m = 2...
% SAME THING...

pa1all   = pa1(:); pa2all = pa2(:); pa3all = pa3(:); pa4all = pa4(:); 

welf_all   = welf(:);
matres   = [welf_all,pa1all,pa2all,pa3all,pa4all]; % CREATE FINAL TABLE: SORT FIRST COLUMN (WELFARE) IN ASCENDING ORDER

%xlswrite('D:\Dati\RICERCA\PAPERS\SIVIERO_NOTARPIETRO_house_prices_mp\REVISIONS JMCB MAY 2014\welfare_min_SHOCK_EXP_Welfare_LMP_Rubio\NO_FF_sticky_HP_075.xlsx',matres,'a2:f5000');
