function [ys_,check]=ns_simple_steadystate(ys_,varargin);
%check the version of Dynare: if >4 then the dynare_version command should exist
dyny=0;
if exist('dynare_version')>0

	gg='4';

	else
	gg=which('dynare');
  
end 
% if dynare version >4 then retrieve information from the structure M_, regarding name of model, parameters and variables	
if ~isempty(regexp(gg,'4', 'once'));
    dyny=1;
% assign information to base memory (workspace) to be used by later commands
    M_=evalin('base','M_');
fname_=evalin('base','M_.fname');
assignin('base','fname_',fname_);
lgy_=evalin('base','M_.endo_names');
assignin('base','lgy_',lgy_);
else
    lgy_=evalin('base','M_.endo_names');
end



check=0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Model specific steady state part: 
%%%%%%%%%%%%%%% at the end of this block must have calculated the value of all the endogenous variables

check=0;
% cgap_ss pledge_ss 

global well_ss well_s_ss well_b_ss AP_ss MC_ss UCbis_ss	Y_ss	 AP_D_ss	stuS_ss stuNR_ss  RR_ss
global MC_D_ss	 Z_D_ss	CNR_ss	L_C_ss L_D_ss	
global P_L_ss	Dp_ss	pii_ss	Dp_D_ss	PI_D_ss  W_C_ss	
global W_C_S_ss	W_C_NR_ss	W_D_S_ss	
global N_C_S_ss N_C_NR_ss N_D_S_ss	W_D_NR_ss	N_D_NR_ss	T_D_ss	R_ss				
global PSI_ss	C_ss	Z_ss	DS_ss	DNR_ss	Debt_ss	XI_ss	XINR_ss	UCbisNR_ss	
global UC_ss	UC_D_ss	UCNR_ss UC_DNR_ss	ZP1_D_ss	ZP2_D_ss	ZP1_ss	ZP2_ss	GDP_ss 
global shock_LTV_ss	shock_H_ss	welf_ss

% param_ns_simple;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pii_ss              = 1;
chi_NR              = 0.2;
hetha_D             = 1.0000001;
omega_D             = 0.1;
mu                  = 1.3;
mu_D                = mu;
subv                = 0;                  
subv_D              = 0;
phi_y_D             = mu_D*(1-subv_D);
phi_y               = mu*(1-subv);
diff_betta          = 3.15;
alph_D              = 0.3;
alpha               = 0.3;
alph_LAN            = 0.15;
betta               = 0.99;
tau_D               = 0.01;
Gst                 = 0.18;
Lst                 = 1;
omega_NR            = 0.2	;
sig_l_C             = 2;
sig_l_D         	= 2;
sig_c               = 0.9999;
betta_NR            = 0.960061;
sig_l_D             = 2.000000;
sig_l_C_NR          = 2.000000;
sig_l_D_NR          = 2.000000;

nbeta               = betta;
pii_ss              = (1.00)^(1/4); 
R_ss                = 1/betta*pii_ss - 1; 
PIBAR               =  pii_ss -1;

xi_p                = 0.75;
gamma_p             = 0.0;

xi_p_D              = 0;
gamma_p_D           = 0;

alph_LAN            = 0;
muw_C               = 1 ;
muw_D               = 1 ;

% betta_NR            = 0.98;

%Steady state markups
%mu = 1.3;
%mu_D = mu;
%If we want to cancel the mean effect in the welfare we have to set:  
% subv = 1-1/mu*(1-taust) ;
% subv_D = 1-1/mu_D*(1-taust) ;
%else
% subv = 0;  
% subv_D = 0;


rho_H		=	0.95 ;
rho_LTV     =   0.95 ;
std_H       =   3 ;
std_LTV     =   1.25 ;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

omega_NR = 0.2;
chi_NR   = 0.2;


rho   = 0.9;
r_dy  = 0.0;
r_PI  = 2.1;
r_PID = -1.0;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subv      = 0;                  
subv_D    = 0;
wantTRS   = 0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
phi_y_D   = mu_D*(1-subv_D);
phi_y     = mu*(1-subv);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pii     = pii_ss;
R       = 1/betta*pii - 1; 
G       = 0.18;
P_L     = 1;
MC      = 1/(mu*(1-subv));
MC_D    = 1/(mu_D*(1-subv_D));
PSI     = 1-betta_NR*(1+R)/(pii);
W_C     = MC;
W_D     = MC_D;
T_D     = mu_D*(1-subv_D)*W_D^(1-alph_LAN)/((1-alph_LAN)^(1-alph_LAN))*(P_L/alph_LAN)^alph_LAN;
DC      = (omega_D/(1-omega_D))*(1/(T_D*(1-betta*(1-tau_D))));
DCNR    = (omega_D/(1-omega_D))*1/(T_D*(1-betta_NR*(1-tau_D)-(1-chi_NR)*PSI*pii/(1+R)));
LAND_LD = (W_D/P_L)*(alph_LAN/(1-alph_LAN)); 
ZL      = 1/ phi_y;
ZLD     = (LAND_LD^alph_LAN)/ phi_y_D;
DebtDNR = (1-chi_NR)*T_D *(pii) /(1+R);


big_omega_NR = (omega_NR^omega_NR)*((1-omega_NR)^(1-omega_NR));

NUM     = (1/DCNR)*(1-((omega_NR^2)/(1-Gst)))+tau_D*T_D-(DebtDNR)*(1-(1+R)/pii) - (omega_NR^2)*tau_D;
DEN     = (omega_NR*(1-omega_NR))*(((1/DC)/(1-Gst)) + tau_D);
DDNR    = NUM/DEN;
CCNR    = (1/DC)*DDNR*DCNR;

ZC      = (1/(1-Gst))*(omega_NR/CCNR + (1-omega_NR));
ZDC     = tau_D*omega_NR*DCNR/CCNR + tau_D*(1-omega_NR)*DC;
NC      = (ZDC*((1-omega_NR)*(1-omega_D))/(ZDC/ZC))^(1/(1+sig_l_C));
ND      = ((ZDC/ZC)^(1/(1+sig_l_C)))*NC;

ND2     = phi_y_D*tau_D*(omega_NR/DDNR + (1-omega_NR))/((CCNR*omega_NR/(1-omega_NR))^(omega_NR/(1+sig_l_C)));

ZCNR    = (1/(1-Gst))*(omega_NR + (1-omega_NR)*CCNR);
ZDCNR   = tau_D*omega_NR*DCNR + tau_D*(1-omega_NR)*DC*CCNR;
NCNR    = (ZDCNR*omega_NR*(1-omega_D)/(ZDC/ZC))^(1/(1+sig_l_C));
NDNR    = ((ZDC/ZC)^(1/(1+sig_l_C)))*NCNR;  


L_C     = ((NC)^(1-omega_NR))*((NCNR)^omega_NR);	
Z       = L_C/phi_y;
Z_D     = Z*((ND/NC)^(1+sig_l_C));
C       = 1/(ZC/Z);
DS      = DC*C;
CNR     = 1/(CCNR/C);
DNR     = DCNR*CNR;


W_C_S   = (NC^sig_l_C)*C/(1-omega_D);
W_D_S   = (ND^sig_l_D)*C/(1-omega_D);

W_C_NR   = (NCNR^sig_l_C)*CNR/(1-omega_D);
W_D_NR   = (NDNR^sig_l_D)*CNR/(1-omega_D);
W_D_NR2  = omega_NR*ND*W_D_S/((1-omega_NR)*NDNR);


Z_D1     = tau_D*(omega_NR*DNR+(1-omega_NR)*DS);
Z_D2     = W_D_NR*NDNR/omega_NR;
Z_D3     = W_D_S*ND/(1-omega_NR); 

constL   = Z_D*phi_y_D/(((ND)^(1-omega_NR))*((NDNR)^omega_NR));
L_D      = constL*(((ND)^(1-omega_NR))*((NDNR)^omega_NR));
Z_D4     = L_D/phi_y_D;


W_C2     = (W_C_S^(1-omega_NR))*(W_C_NR^omega_NR)/((omega_NR^omega_NR)*((1-omega_NR)^(1-omega_NR)));												
constW   = W_D/((W_D_S^(1-omega_NR))*(W_D_NR^omega_NR)/((omega_NR^omega_NR)*((1-omega_NR)^(1-omega_NR))));
W_D2     = constW*(W_D_S^(1-omega_NR))*(W_D_NR^omega_NR)/((omega_NR^omega_NR)*((1-omega_NR)^(1-omega_NR)));

XINR     = (CNR^(1-omega_D))*(DNR^(omega_D))*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
UCbisNR  = 1/XINR;
UCNR     = UCbisNR*(1-omega_D)*(CNR/DNR)^(-omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));			
UC_DNR   = UCbisNR*omega_D*(CNR/DNR)^(1-omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
Debt     = (1-chi_NR)*T_D * DNR*(pii) /(1+R);

LANDst   = LAND_LD * L_D;

Y        = omega_NR*CNR+(1-omega_NR)*C + Gst*Z;		


% here I allow for transfers to equalize C and CNR (maybe useful in Ramsey
% allocation)
if wantTRS
    CCNR     = 1;
    ZC       = (1/(1-Gst))*(omega_NR/CCNR + (1-omega_NR));
    ZDC      = tau_D*omega_NR*DCNR/CCNR + tau_D*(1-omega_NR)*DC;
    NC       = (ZDC*((1-omega_NR)*(1-omega_D))/(ZDC/ZC))^(1/(1+sig_l_C));
    ND       = ((ZDC/ZC)^(1/(1+sig_l_C)))*NC;
    ND2      = phi_y_D*tau_D*(omega_NR/DDNR + (1-omega_NR))/((CCNR*omega_NR/(1-omega_NR))^(omega_NR/(1+sig_l_C)));
    ZCNR     = (1/(1-Gst))*(omega_NR + (1-omega_NR)*CCNR);
    ZDCNR    = tau_D*omega_NR*DCNR + tau_D*(1-omega_NR)*DC*CCNR;
    NCNR     = (ZDCNR*omega_NR*(1-omega_D)/(ZDC/ZC))^(1/(1+sig_l_C));
    NDNR     = ((ZDC/ZC)^(1/(1+sig_l_C)))*NCNR;  
    L_C      = ((NC)^(1-omega_NR))*((NCNR)^omega_NR);	
    Z        = L_C/phi_y;
    Z_D      = Z*((ND/NC)^(1+sig_l_C));
    C        = 1/(ZC/Z);
    DS       = DC*C;
    CNR      = C;
    DNR      = DCNR*C;
    W_C_S    = (NC^sig_l_C)*C/(1-omega_D);
    W_D_S    = (ND^sig_l_D)*C/(1-omega_D);
    W_C_NR   = (NCNR^sig_l_C)*CNR/(1-omega_D);
    W_D_NR   = (NDNR^sig_l_D)*CNR/(1-omega_D);
    W_D_NR2  = omega_NR*ND*W_D_S/((1-omega_NR)*NDNR);
    Z_D1     = tau_D*(omega_NR*DNR+(1-omega_NR)*DS);
    Z_D2     = W_D_NR*NDNR/omega_NR;
    Z_D3     = W_D_S*ND/(1-omega_NR);
    constL   = Z_D*phi_y_D/(((ND)^(1-omega_NR))*((NDNR)^omega_NR));
    L_D      = constL*(((ND)^(1-omega_NR))*((NDNR)^omega_NR));
    Z_D4     = L_D/phi_y_D;
    W_C2     = (W_C_S^(1-omega_NR))*(W_C_NR^omega_NR)/((omega_NR^omega_NR)*((1-omega_NR)^(1-omega_NR)));												
    constW   = W_D/((W_D_S^(1-omega_NR))*(W_D_NR^omega_NR)/((omega_NR^omega_NR)*((1-omega_NR)^(1-omega_NR))));
    W_D2     = constW*(W_D_S^(1-omega_NR))*(W_D_NR^omega_NR)/((omega_NR^omega_NR)*((1-omega_NR)^(1-omega_NR)));
    XINR     = (CNR^(1-omega_D))*(DNR^(omega_D))*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
    UCbisNR  = 1/XINR;
    UCNR     = UCbisNR*(1-omega_D)*(CNR/DNR)^(-omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));			
    UC_DNR   = UCbisNR*omega_D*(CNR/DNR)^(1-omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
    Debt     = (1-chi_NR)*T_D * DNR*(pii) /(1+R);
    Y        = omega_NR*CNR+(1-omega_NR)*C + Gst*Z;		
    LANDst   = LAND_LD * L_D;
    TRS      = C  + T_D * tau_D*DNR -Debt*(-(1+R)/(pii)+1) - NCNR*W_C_NR-NDNR*W_D_NR ;
end

XI      = (C^(1-omega_D))*(DS^(omega_D))*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
UCbis   = 1/XI;
UC      = UCbis*(1-omega_D)*(C/DS)^(-omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));
UC_D    = UCbis*omega_D*(C/DS)^(1-omega_D)*(1/((omega_D^omega_D)*((1-omega_D)^(1-omega_D))));

AP      = (pii)^(1-gamma_p)*(pii)^(gamma_p-1);	
PI_D    =  pii -1 ;		
AP_D    = (1+PI_D)*(1+PI_D)^(-gamma_p_D)*(1+PI_D)^(gamma_p_D-1);
ZP1_D   = UC*MC_D*Z_D*T_D/(1-betta*xi_p_D*AP_D^(mu_D/(mu_D-1)));
ZP2_D   = UC*Z_D*T_D/(1-betta*xi_p_D*AP_D^(1/(mu_D-1)));
ZP1     = UC*MC*Z/(1-betta*xi_p*AP^(mu/(mu-1)));
ZP2     = UC*Z/(1-betta*xi_p*AP^(1/(mu-1)));
Dp      = ((1-xi_p)*(mu*(1-subv)*ZP1/ZP2)^(-mu/(mu-1)))/ (1-xi_p*AP^(mu/(mu-1)));
Dp_D    = ((1-xi_p_D)*(mu_D*(1-subv_D)*ZP1_D/ZP2_D)^(-mu_D/(mu_D-1)))/(1-xi_p_D*AP_D^(mu_D/(mu_D-1)));	

W       = W_C;
WT      = omega_NR^omega_NR*(1-omega_NR)^(1-omega_NR)*W;
WC      = MC ;
WD      = MC_D ;
WTILD_C   = WT/W*WC; 
WTILD_D   = WT/W*WD;
WTILD_CNR = WTILD_C; 
WTILD_DNR = WTILD_D;
LCBAR     = UC*W_C_S*(NC)^(-sig_l_C);
LDBAR     = UC*W_D_S*(ND)^(-sig_l_D);
LC_NRBAR  = UCNR*W_C_NR*(NCNR)^(-sig_l_C_NR);
LD_NRBAR  = UCNR*W_D_NR*(NDNR)^(-sig_l_D_NR);
GDP       = Z  + Z_D * T_D ;
TOTC      = omega_NR*CNR + (1-omega_NR)*C;				

N_C_S     = NC;
N_C_NR    = NCNR;
N_D_S     = ND;
N_D_NR    = NDNR;

shock_LTV  = 0; 
shock_H    = 0; 

stuS     = (log(XI)- LCBAR*(N_C_S)^(1+sig_l_C)/(1+sig_l_C)-LDBAR*(N_D_S)^(1+sig_l_D)/(1+sig_l_D));

stuNR    = (log(XINR)-LC_NRBAR*(N_C_NR)^(1+sig_l_C_NR)/(1+sig_l_C_NR)- LD_NRBAR*(N_D_NR)^(1+sig_l_D_NR)/(1+sig_l_D_NR));

cgap     = C/CNR;

pledge = exp(shock_LTV)*(1-chi_NR);

stuff = (1-omega_NR)*(1-betta)*(stuS) + omega_NR*(1-betta_NR)*(stuNR) ;


well_s = stuS/(1-betta);
well_b = stuNR/(1-betta_NR);
well = (1-omega_NR)*(1-betta)*well_s + omega_NR*(1-betta_NR)*well_b;

Util   = stuff;
welf   = Util;

RR  = (R  /pii(+1));

shock_LTV_ss	=	shock_LTV	;
shock_H_ss	    =	shock_H;	
stuS_ss     = stuS;
stuNR_ss    = stuNR;
RR_ss       = RR;
AP_ss       =	AP      ;
MC_ss       =	MC	;
UCbis_ss	=	UCbis	;
Y_ss        =	Y	;
Z_ss        =	Z	;
AP_D_ss     =	AP_D	;
MC_D_ss     =	MC_D	;
XINR_ss     =	XINR	;
XI_ss       =	XI	;
UCbisNR_ss	=	UCbisNR	;
Z_D_ss      =	Z_D	;
UC_ss       =	UC	;
C_ss        =	C	;
UC_D_ss     =	UC_D	;
DS_ss       =	DS	;
UCNR_ss     =	UCNR	;
CNR_ss      =	CNR	;
UC_DNR_ss	=	UC_DNR	;
DNR_ss      =	DNR	;
PSI_ss      =	PSI	;
Debt_ss     =	Debt	;
L_C_ss      =	L_C	;
L_D_ss      =	L_D	;
P_L_ss      =	P_L	;
Dp_ss       =	Dp	;
pii_ss      =	pii	;
ZP1_ss      =	ZP1	;
ZP2_ss      =	ZP2	;
Dp_D_ss     =	Dp_D	;
PI_D_ss     =	PI_D	;
ZP1_D_ss	=	ZP1_D	;
ZP2_D_ss	=	ZP2_D	;
W_C_ss      =	W_C	;
W_C_S_ss	=	W_C_S	;
N_C_S_ss	=	N_C_S	;
W_C_NR_ss	=	W_C_NR	;
N_C_NR_ss	=	N_C_NR	;
W_D_S_ss	=	W_D_S	;
N_D_S_ss	=	N_D_S	;
W_D_NR_ss	=	W_D_NR	;
N_D_NR_ss	=	N_D_NR	;
T_D_ss      =	T_D	;
GDP_ss      =	GDP	;
R_ss        =	R	;
welf_ss     =   welf;
well_s_ss   = well_s;
well_b_ss   = well_b;
well_ss     = well;

%%%%%% IMPORTANT definition of vector of variables' names
lgy_=evalin('base','lgy_');% this still is needed as a place-holder for Ramsey stuff

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Assignment of values to names, to global names and to steady-state
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% parametrization of the variables
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Notice that in the previous block we assigned log(value) to all the variables
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% for this reason we don't take logs again. This would be the case also if the model
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% is in level-deviations
nolog=1;
for kkk=1:size(lgy_,1)

    if exist(deblank(lgy_(kkk,:)),'var') % a variable might not have been computed
        tmp=lgy_(kkk,:);
    else
        tmp=[deblank(lgy_(kkk,:)),'_ss'];
    end
    if nolog % for the non-log case (see comment above)
        ys_((kkk),1)=(eval(deblank(tmp)));
        eval(['global  ',deblank(lgy_(kkk,:)),'_ss']);

        %         lgy_(kkk,:)
        eval([deblank(lgy_(kkk,:)),'_ss=(',lgy_(kkk,:),');'])

    else
        ys_((kkk),1)=log(eval(deblank(tmp)));
        eval(['global  ',deblank(lgy_(kkk,:)),'_ss']);

        %         lgy_(kkk,:)
        eval([deblank(lgy_(kkk,:)),'_ss=log(',lgy_(kkk,:),');'])

    end

end

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% THE FOLLOWING SHOULD BE REALLY MODEL INDEPENDENT
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% It updates the value of the parameters in the M_ structure
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% in case parameters have been changed (e.g. if endogenized in the steady state etc.)
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% If you don't have this case, either you don't bother or you comment it out (choose the first)
%     keyboard
    if dyny
for jj=1:size(M_.param_names,1)
    if exist(deblank(M_.param_names(jj,:)),'var');
        
        tmp=eval(M_.param_names(jj,:));
      
    else
        tmp=0;
    end
    if isempty(tmp);tmp=0;end
%     M_.param_names(jj,:)
    
    M_.params(jj,1)=tmp;
%     M_.params(jj,:)
end

assignin('base','M_',M_);
assignin('base','ys_',ys_);

    end
%     keyboard
return



